package dev.shadowsoffire.apotheosis.util;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.common.collect.ImmutableSet;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonElement;
import com.google.gson.stream.JsonWriter;
import com.mojang.serialization.DynamicOps;
import com.mojang.serialization.JsonOps;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.loot.AffixLootEntry;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Set;
import java.util.function.BiConsumer;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.ArmorItem;
import net.minecraft.world.item.ArmorMaterial;
import net.minecraft.world.item.ArmorMaterials;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Tier;
import net.minecraft.world.item.TieredItem;
import net.minecraft.world.item.Tiers;
import net.minecraft.world.level.ItemLike;
import net.minecraftforge.fml.loading.FMLPaths;
import net.minecraftforge.registries.ForgeRegistries;

public class MiscDatagenCode {
  private static final DynamicHolder<LootRarity> COMMON = RarityRegistry.INSTANCE.holder(Apotheosis.loc("common"));
  
  private static final DynamicHolder<LootRarity> UNCOMMON = RarityRegistry.INSTANCE.holder(Apotheosis.loc("uncommon"));
  
  private static final DynamicHolder<LootRarity> RARE = RarityRegistry.INSTANCE.holder(Apotheosis.loc("rare"));
  
  private static final DynamicHolder<LootRarity> EPIC = RarityRegistry.INSTANCE.holder(Apotheosis.loc("epic"));
  
  private static final DynamicHolder<LootRarity> MYTHIC = RarityRegistry.INSTANCE.holder(Apotheosis.loc("mythic"));
  
  private static final Gson GSON = (new GsonBuilder()).setPrettyPrinting().create();
  
  public static void genAffixLootItems() {
    ImmutableSet immutableSet1 = ImmutableSet.of(new ResourceLocation("overworld"));
    ImmutableSet immutableSet2 = ImmutableSet.of(new ResourceLocation("the_nether"));
    ImmutableSet immutableSet3 = ImmutableSet.of(new ResourceLocation("the_end"));
    BiConsumer<String, AffixLootEntry> writerFunc = (dim, entry) -> {
        if (entry.getType().isNone())
          return; 
        File file = new File(FMLPaths.GAMEDIR.get().toFile(), "datagen/" + dim + "/" + ForgeRegistries.ITEMS.getKey(entry.getStack().m_41720_()).m_135815_() + ".json");
        file.getParentFile().mkdirs();
        try {
          FileWriter writer = new FileWriter(file);
          try {
            JsonWriter jWriter = new JsonWriter(writer);
            jWriter.setIndent("    ");
            JsonElement json = AffixLootEntry.CODEC.encodeStart((DynamicOps)JsonOps.INSTANCE, entry).get().left().get();
            GSON.toJson(json, jWriter);
            writer.close();
          } catch (Throwable throwable) {
            try {
              writer.close();
            } catch (Throwable throwable1) {
              throwable.addSuppressed(throwable1);
            } 
            throw throwable;
          } 
        } catch (IOException ex) {
          throw new RuntimeException(ex);
        } 
      };
    for (Item i : ForgeRegistries.ITEMS) {
      if (i instanceof TieredItem) {
        TieredItem t = (TieredItem)i;
        Tier tier = t.m_43314_();
        if (tier instanceof Tiers) {
          Tiers tiers = (Tiers)tier;
          if (tiers.ordinal() > Tiers.STONE.ordinal() && tiers.ordinal() <= Tiers.IRON.ordinal()) {
            AffixLootEntry entry = new AffixLootEntry(100 - 15 * (tiers.ordinal() - 1), (1 + 3 * (tiers.ordinal() - 1)), new ItemStack((ItemLike)i), (Set)immutableSet1, COMMON, RARE);
            writerFunc.accept("overworld", entry);
          } 
          if ((tiers.ordinal() >= Tiers.IRON.ordinal() && tiers.ordinal() <= Tiers.DIAMOND.ordinal()) || tiers == Tiers.GOLD) {
            int weight = (tiers == Tiers.GOLD) ? 85 : (100 - 30 * (tiers.ordinal() - 2));
            int quality = (tiers == Tiers.GOLD) ? 5 : (1 + 5 * (tiers.ordinal() - 2));
            AffixLootEntry entry = new AffixLootEntry(weight, quality, new ItemStack((ItemLike)i), (Set)immutableSet2, UNCOMMON, EPIC);
            writerFunc.accept("the_nether", entry);
          } 
          if (tiers.ordinal() >= Tiers.DIAMOND.ordinal()) {
            int weight = (tiers == Tiers.DIAMOND) ? 100 : 70;
            int quality = (tiers == Tiers.DIAMOND) ? 5 : 10;
            AffixLootEntry entry = new AffixLootEntry(weight, quality, new ItemStack((ItemLike)i), (Set)immutableSet3, RARE, MYTHIC);
            writerFunc.accept("the_end", entry);
          } 
          continue;
        } 
      } 
      if (i instanceof ArmorItem) {
        ArmorItem a = (ArmorItem)i;
        ArmorMaterial armorMaterial = a.m_40401_();
        if (armorMaterial instanceof ArmorMaterials) {
          ArmorMaterials mat = (ArmorMaterials)armorMaterial;
          if (mat.ordinal() <= ArmorMaterials.IRON.ordinal()) {
            AffixLootEntry entry = new AffixLootEntry(100 - 15 * mat.ordinal(), (1 + 2 * mat.ordinal()), new ItemStack((ItemLike)i), (Set)immutableSet1, COMMON, RARE);
            writerFunc.accept("overworld", entry);
          } 
          if (mat.ordinal() >= ArmorMaterials.IRON.ordinal() && mat.ordinal() <= ArmorMaterials.DIAMOND.ordinal()) {
            AffixLootEntry entry = new AffixLootEntry(100 - 15 * (mat.ordinal() - 2), (1 + 2 * (mat.ordinal() - 2)), new ItemStack((ItemLike)i), (Set)immutableSet2, UNCOMMON, EPIC);
            writerFunc.accept("the_nether", entry);
          } 
          if (mat == ArmorMaterials.DIAMOND || mat == ArmorMaterials.NETHERITE) {
            int weight = (mat == ArmorMaterials.DIAMOND) ? 100 : 70;
            int quality = (mat == ArmorMaterials.DIAMOND) ? 5 : 10;
            AffixLootEntry entry = new AffixLootEntry(weight, quality, new ItemStack((ItemLike)i), (Set)immutableSet3, RARE, MYTHIC);
            writerFunc.accept("the_end", entry);
          } 
        } 
      } 
    } 
  }
}
